﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Demorto#2660) Version 7.2.5.0 (19:35 07.08.2017)
------------------------------------------------------------------------------------
--
-- Bars Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

function BarsColorizeModule_Init(Cfg)

	-- Запилить проверку показан ли тект стандартный на барах

		local DefaultFont,_,_  = PlayerName:GetFont()
		local DefaultSize = 8
		local DefaultStyle = "OUTLINE"
		
		if string.upper(Cfg.BarsTextFont) ~= "STANDART" then
			DefaultFont = Cfg.BarsTextFont
		end
		
		if string.upper(Cfg.BarsTextSize) ~= "STANDART" then
			DefaultSize = Cfg.BarsTextSize
		end
		
		if string.upper(Cfg.BarsTextStyle) ~= "STANDART" then
			DefaultStyle = Cfg.BarsTextStyle
		end
		
		function TextOnBars_Initialization(ParentFrame, SizeX, SizeY, PointA, PointX, PointY, Font, Size, Style, Prefix)
			local MainFrame = "NC"..ParentFrame:GetName().."ScrollFrame"
			local TextFrame = "NC"..ParentFrame:GetName().."TextFrame"
			local TextPercentText = "NC"..ParentFrame:GetName().."TextFrame"..Prefix.."PercentText"
			local TextCurrentText = "NC"..ParentFrame:GetName().."TextFrame"..Prefix.."CurrentText"
			
			local MainFrame = CreateFrame("ScrollFrame", nil, ParentFrame)
			MainFrame:SetSize(SizeX, SizeY)
			MainFrame:SetPoint(PointA, PointX, PointY)

			local TextFrame = CreateFrame("Frame", nil, MainFrame)
			TextFrame:SetSize(SizeX * 2, SizeY)
			TextFrame:SetPoint("CENTER")

			local TextPercentText = TextFrame:CreateFontString("NC"..ParentFrame:GetName().."TextFrame"..Prefix.."PercentText", "OVERLAY")
			TextPercentText:ClearAllPoints()
			TextPercentText:SetFont(Font, Size, Style)
			TextPercentText:SetWordWrap(false)

			local TextCurrentText = TextFrame:CreateFontString("NC"..ParentFrame:GetName().."TextFrame"..Prefix.."CurrentText", "OVERLAY")
			TextCurrentText:ClearAllPoints()
			TextCurrentText:SetFont(Font, Size, Style)
			TextCurrentText:SetWordWrap(false)

			MainFrame:SetScrollChild(TextFrame)
			
			return {TextPercentText, TextCurrentText}
		end
		
		function TextOnBars_Update(NCBar, Bar, BarText, Unit, Alpha, Prefix, ToShow, DeathMod)
			if Cfg.ModuleEnable then
				local Show = string.upper(ToShow)
				if Prefix == "HP" then
					local MinValue, MaxValue = Bar:GetMinMaxValues()
					local Position = (Bar:GetValue() / MaxValue) * Bar:GetWidth() or 0
					local CurHP = UnitHealth(Unit)
					local MaxHP = UnitHealthMax(Unit)
					local Pct = math.ceil(100*(CurHP / MaxHP))
					local R, G, B, _ = Bar:GetStatusBarColor()
					local NCBarPercentText, NCBarCurrentText = NCBar[1], NCBar[2]
					
					if UnitIsConnected(Unit) then
						if not UnitIsDeadOrGhost(Unit) then
							if not BarText:GetText() then
								if (Show == "BOTH" or Show == "PERCENT") then
									NCBarPercentText:Show()
									NCBarPercentText:SetTextColor(R, G, B, Alpha)
									NCBarPercentText:SetText(format("%.0f%%",Pct))
									NCBarPercentText:SetPoint("LEFT", Bar, "LEFT", Position + 1, -0.5)
									NCBarPercentText:SetJustifyH("LEFT")
								else
									NCBarPercentText:Hide()
								end
								
								if (Show == "BOTH" or Show == "CURRENT") then
									NCBarCurrentText:Show()
									NCBarCurrentText:SetTextColor(R, G, B, Alpha)
									NCBarCurrentText:SetText(AbbreviateLargeNumbers(CurHP))
									NCBarCurrentText:SetPoint("RIGHT", Bar, "LEFT", Position + 1, -0.5)
									NCBarCurrentText:SetJustifyH("RIGHT")
								else
									NCBarCurrentText:Hide()
								end
							else
								NCBarPercentText:Hide()
								NCBarCurrentText:Hide()
							end
						else
							if not BarText:GetText() then
								if DeathMod then
									NCBarPercentText:Show()
									NCBarPercentText:SetTextColor(R, G, B, Alpha)
									if Unit == "player" then
										NCBarPercentText:SetText(SPELL_FAILED_CASTER_DEAD)
									else
										NCBarPercentText:SetText(DEAD..".")
									end
									NCBarPercentText:ClearAllPoints()
									NCBarPercentText:SetPoint("CENTER", Bar, "CENTER", 0, -0.5)
									NCBarPercentText:SetJustifyH("LEFT")
								end
								NCBarCurrentText:Hide()
							else
								NCBarPercentText:Hide()
								NCBarCurrentText:Hide()
							end
						end
					else
						if not BarText:GetText() then
							NCBarPercentText:Show()
							NCBarPercentText:SetTextColor(R, G, B, Alpha)
							NCBarPercentText:SetText(PLAYER_OFFLINE)
							NCBarPercentText:ClearAllPoints()
							NCBarPercentText:SetPoint("CENTER", Bar, "CENTER", 0, -0.5)
							NCBarPercentText:SetJustifyH("LEFT")
							NCBarCurrentText:Hide()
						else
							NCBarPercentText:Hide()
							NCBarCurrentText:Hide()
						end
					end
				elseif Prefix == "MP" then
					local MinValue, MaxValue = Bar:GetMinMaxValues()
					local Position = (Bar:GetValue() / MaxValue) * Bar:GetWidth() or 0
					local powerType, powerToken = UnitPowerType(Unit)
					local CurPower = UnitPower(Unit)
					local MaxPower = UnitPowerMax(Unit)
					local Pct = math.ceil(100*(CurPower / MaxPower)) or 0
					local NCBarPercentText, NCBarCurrentText = NCBar[1], NCBar[2]

					local R, G, B = (PowerBarColor[powerType].r * 1.2), (PowerBarColor[powerType].g * 1.2), (PowerBarColor[powerType].b * 1.2)
					
					if UnitIsConnected(Unit) then
						Bar:SetStatusBarColor(PowerBarColor[powerType].r, PowerBarColor[powerType].g, PowerBarColor[powerType].b)
						if not UnitIsDeadOrGhost(Unit) then
							Bar:SetAlpha(1)
							if not BarText:GetText() then
								if (Show == "BOTH" or Show == "PERCENT") then
									NCBarPercentText:Show()
									NCBarPercentText:SetTextColor(R, G, B, Alpha)
									NCBarPercentText:SetText(format("%.0f%%",Pct))
									NCBarPercentText:SetPoint("LEFT", Bar, "LEFT", Position + 1, -0.5)
									NCBarPercentText:SetJustifyH("LEFT")
								else
									NCBarPercentText:Hide()
								end
								if (Show == "BOTH" or Show == "CURRENT") then
									NCBarCurrentText:Show()
									NCBarCurrentText:SetTextColor(R, G, B, Alpha)
									NCBarCurrentText:SetText(AbbreviateLargeNumbers(CurPower))
									NCBarCurrentText:SetPoint("RIGHT", Bar, "LEFT", Position, -0.5)
									NCBarCurrentText:SetJustifyH("RIGHT")
								else
									NCBarCurrentText:Hide()
								end
							else
								NCBarPercentText:Hide()
								NCBarCurrentText:Hide()
							end
						else
							if DeathMod then
								Bar:SetAlpha(0)
								NCBarPercentText:Hide()
								NCBarCurrentText:Hide()
							end
						end
					else
						Bar:SetStatusBarColor(0.5, 0.5, 0.5)
						NCBarPercentText:Hide()
						NCBarCurrentText:Hide()
					end
				end
			else
				if NCBar[1]:IsShown() then NCBar[1]:Hide() end
				if NCBar[2]:IsShown() then NCBar[2]:Hide() end
			end
		end
		
		function ColorizeBars(Bar, Unit, Enable)
			if (Enable and Cfg.ModuleEnable) then
				local CurHP = UnitHealth(Unit)
				local MaxHP = UnitHealthMax(Unit)
				local Pct = math.ceil(100*(CurHP / MaxHP))
				local R, G, B = 0, 1, 0
				if UnitIsConnected(Unit) then
					if (Pct >= 75) then
						R, G, B = 0, 1, 0
					elseif (Pct < 75 and Pct >= 50) then
						R, G, B = 1, 1, 0
					elseif (Pct < 50 and Pct >= 25) then
						R, G, B = 1, 0.5, 0
					else
						R, G, B = 1, 0, 0
					end
				else
					R, G, B = 0.5, 0.5, 0.5
				end
				Bar:SetStatusBarColor(R, G, B)
			else
				Bar:SetStatusBarColor(0, 1, 0)
			end
		end
		
		NCPlayerHPText = TextOnBars_Initialization(PlayerFrame, 119, 12, "TOPLEFT", 106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
		NCPlayerMPText = TextOnBars_Initialization(PlayerFrame, 119, 12, "TOPLEFT", 106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
		
		NCTargetHPText = TextOnBars_Initialization(TargetFrame, 119, 12, "TOPRIGHT", -106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
		NCTargetMPText = TextOnBars_Initialization(TargetFrame, 119, 12, "TOPRIGHT", -106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
		
		NCFocusHPText = TextOnBars_Initialization(FocusFrame, 119, 12, "TOPRIGHT", -106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
		NCFocusMPText = TextOnBars_Initialization(FocusFrame, 119, 12, "TOPRIGHT", -106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
		
		PlayerFrameMyHealPredictionBar:SetParent(PlayerFrameHealthBar)
		PlayerFrameOtherHealPredictionBar:SetParent(PlayerFrameHealthBar)
		PlayerFrameHealAbsorbBar:SetParent(PlayerFrameHealthBar)
		PlayerFrameHealAbsorbBarLeftShadow:SetParent(PlayerFrameHealthBar)
		PlayerFrameHealAbsorbBarRightShadow:SetParent(PlayerFrameHealthBar)

		for i, v in pairs({
				PlayerFrameHealthBar,
				TargetFrameHealthBar,
				FocusFrameHealthBar,
				TargetFrameToTHealthBar,
				PartyMemberFrame1HealthBar,
				PartyMemberFrame2HealthBar,
				PartyMemberFrame3HealthBar,
				PartyMemberFrame4HealthBar,
				Boss1TargetFrameHealhBar,
				Boss2TargetFrameHealhBar,
				Boss3TargetFrameHealhBar,
				Boss4TargetFrameHealhBar,
				Boss5TargetFrameHealhBar,
				ArenaEnemyFrame1HealthBar,
				ArenaEnemyFrame2HealthBar,
				ArenaEnemyFrame3HealthBar,
				ArenaEnemyFrame4HealthBar,
				ArenaEnemyFrame5HealthBar,
				PetFrameHealthBar,
				}) do
					v.lockColor = Cfg.BarsColorizeEnable
			end

		PlayerFrameHealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.TextAlpha, "HP", Cfg.PlayerHealthBarText, Cfg.BarsDeathMod)
		end)
		
		PlayerFrameHealthBar:HookScript("OnLeave", function()
			ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.TextAlpha, "HP", Cfg.PlayerHealthBarText, Cfg.BarsDeathMod)
		end)
		
		PlayerFrameHealthBar:HookScript("OnEnter", function()
			ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.TextAlpha, "HP", Cfg.PlayerHealthBarText, Cfg.BarsDeathMod)
		end)
		
		PlayerFrameManaBar:HookScript("OnValueChanged", function()
			TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.TextAlpha, "MP", Cfg.PlayerPowerBarText, Cfg.BarsDeathMod)	
		end)
		
		PlayerFrameManaBar:HookScript("OnLeave", function()
			TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.TextAlpha, "MP", Cfg.PlayerPowerBarText, Cfg.BarsDeathMod)	
		end)
		
		PlayerFrameManaBar:HookScript("OnEnter", function()
			TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.TextAlpha, "MP", Cfg.PlayerPowerBarText, Cfg.BarsDeathMod)	
		end)
		
		---
		
		TargetFrameHealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
		end)
		
		TargetFrameHealthBar:HookScript("OnLeave", function()
			ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
		end)
		
		TargetFrameHealthBar:HookScript("OnEnter", function()
			ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
		end)
		
		TargetFrameManaBar:HookScript("OnValueChanged", function()
			TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)
		end)
		
		TargetFrameManaBar:HookScript("OnLeave", function()
			TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)
		end)
		
		TargetFrameManaBar:HookScript("OnEnter", function()
			TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)
		end)
		
		---
		
		FocusFrameHealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
		end)
		
		FocusFrameHealthBar:HookScript("OnLeave", function()
				ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
		end)
		
		FocusFrameHealthBar:HookScript("OnEnter", function()
				ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
		end)
		
		FocusFrameManaBar:HookScript("OnValueChanged", function()
				TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
		end)
		
		FocusFrameManaBar:HookScript("OnLeave", function()
				TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
		end)
		
		FocusFrameManaBar:HookScript("OnEnter", function()
				TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
		end)
		
		---
		
		hooksecurefunc("UnitFrame_Update", function(Frame)
			if Frame.unit == "player" then
				ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.TextAlpha, "HP", Cfg.PlayerHealthBarText, Cfg.BarsDeathMod)
				TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.TextAlpha, "MP", Cfg.PlayerPowerBarText, Cfg.BarsDeathMod)
			elseif Frame.unit == "target" then
				ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
				TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)
			elseif Frame.unit == "focus" then
				ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
				TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
			end
		end)
		
		---
		
		TargetFrameToTHealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(TargetFrameToTHealthBar, "targettarget", Cfg.BarsColorizeEnable)
		end)
		
		PartyMemberFrame1HealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PartyMemberFrame1HealthBar, "party1", Cfg.BarsColorizeEnable)
		end)
		
		PartyMemberFrame2HealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PartyMemberFrame2HealthBar, "party2", Cfg.BarsColorizeEnable)
		end)
		
		PartyMemberFrame3HealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PartyMemberFrame3HealthBar, "party3", Cfg.BarsColorizeEnable)
		end)
		
		PartyMemberFrame4HealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PartyMemberFrame4HealthBar, "party4", Cfg.BarsColorizeEnable)
		end)
		
		local NCArenaAddonFrame = CreateFrame("Frame")
		NCArenaAddonFrame:RegisterEvent("ADDON_LOADED")
		NCArenaAddonFrame:SetScript("OnEvent", function(Self, Event, ...)
			local Addon = ...
			if (Event == "ADDON_LOADED" and Addon == "Blizzard_ArenaUI") then
				ArenaEnemyFrame1HealthBar:HookScript("OnValueChanged", function()
					ColorizeBars(ArenaEnemyFrame1HealthBar, "arena1", Cfg.BarsColorizeEnable)
				end)
				
				ArenaEnemyFrame2HealthBar:HookScript("OnValueChanged", function()
					ColorizeBars(ArenaEnemyFrame2HealthBar, "arena2", Cfg.BarsColorizeEnable)
				end)
				
				ArenaEnemyFrame3HealthBar:HookScript("OnValueChanged", function()
					ColorizeBars(ArenaEnemyFrame3HealthBar, "arena3", Cfg.BarsColorizeEnable)
				end)
				
				ArenaEnemyFrame4HealthBar:HookScript("OnValueChanged", function()
					ColorizeBars(ArenaEnemyFrame4HealthBar, "arena4", Cfg.BarsColorizeEnable)
				end)
				
				ArenaEnemyFrame5HealthBar:HookScript("OnValueChanged", function()
					ColorizeBars(ArenaEnemyFrame5HealthBar, "arena5", Cfg.BarsColorizeEnable)
				end)
			end
		end)

		PetFrameHealthBar:HookScript("OnValueChanged", function()
			ColorizeBars(PetFrameHealthBar, "pet", Cfg.BarsColorizeEnable)
		end)

		local NCConnectFrame = CreateFrame("Frame")
		NCArenaAddonFrame:RegisterEvent("UNIT_CONNECTION")
		NCArenaAddonFrame:SetScript("OnEvent", function(Self, Event, ...)
			local Unit, Status = ...
			if Unit == "target" then
				ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
				TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)		
			elseif Unit == "focus" then
				ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
				TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
				TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
			elseif Unit == "party1" then
				ColorizeBars(PartyMemberFrame1HealthBar, "party1", Cfg.BarsColorizeEnable)
			elseif Unit == "party2" then
				ColorizeBars(PartyMemberFrame2HealthBar, "party2", Cfg.BarsColorizeEnable)
			elseif Unit == "party3" then
				ColorizeBars(PartyMemberFrame3HealthBar, "party3", Cfg.BarsColorizeEnable)
			elseif Unit == "party4" then
				ColorizeBars(PartyMemberFrame4HealthBar, "party4", Cfg.BarsColorizeEnable)
			end
		end)
		
		hooksecurefunc("TargetFrame_CheckDead", function()
			if Cfg.BarsDeathMod then
				if TargetFrameTextureFrameDeadText:GetText() then TargetFrameTextureFrameDeadText:Hide() end
				if FocusFrameTextureFrameDeadText:GetText() then FocusFrameTextureFrameDeadText:Hide() end
			end
		end)
	return true
end

function BarsColorizeModule_Update(Cfg)
		if PlayerFrame:IsShown() then
			ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.TextAlpha, "HP", Cfg.PlayerHealthBarText, Cfg.BarsDeathMod)
			TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.TextAlpha, "MP", Cfg.PlayerPowerBarText, Cfg.BarsDeathMod)
		end
		
		if TargetFrame:IsShown() then
			ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.TextAlpha, "HP", Cfg.TargetHealthBarText, Cfg.BarsDeathMod)
			TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.TextAlpha, "MP", Cfg.TargetPowerBarText, Cfg.BarsDeathMod)
		end
		
		if FocusFrame:IsShown() then
			ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorizeEnable)
			TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.TextAlpha, "HP", Cfg.FocusHealthBarText, Cfg.BarsDeathMod)
			TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.TextAlpha, "MP", Cfg.FocusPowerBarText, Cfg.BarsDeathMod)
		end
			
		if TargetFrameToT:IsShown() then
			ColorizeBars(TargetFrameToTHealthBar, "targettarget", Cfg.BarsColorizeEnable)
		end
		
		if PartyMemberFrame1:IsShown() then
			ColorizeBars(PartyMemberFrame1HealthBar, "party1", Cfg.BarsColorizeEnable)
		end
		
		if PartyMemberFrame2:IsShown() then
			ColorizeBars(PartyMemberFrame2HealthBar, "party2", Cfg.BarsColorizeEnable)
		end
		
		if PartyMemberFrame3:IsShown() then
			ColorizeBars(PartyMemberFrame3HealthBar, "party3", Cfg.BarsColorizeEnable)
		end
		
		if PartyMemberFrame4:IsShown() then
			ColorizeBars(PartyMemberFrame4HealthBar, "party4", Cfg.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame1 then
			ColorizeBars(ArenaEnemyFrame1HealthBar, "arena1", Cfg.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame2 then
			ColorizeBars(ArenaEnemyFrame2HealthBar, "arena2", Cfg.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame3 then
			ColorizeBars(ArenaEnemyFrame3HealthBar, "arena3", Cfg.BarsColorizeEnable)
		end
			
		if ArenaEnemyFrame4 then
			ColorizeBars(ArenaEnemyFrame4HealthBar, "arena4", Cfg.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame5 then
			ColorizeBars(ArenaEnemyFrame5HealthBar, "arena5", Cfg.BarsColorizeEnable)
		end
		
		if PetFrame:IsShown() then
			ColorizeBars(PetFrameHealthBar, "pet", Cfg.BarsColorizeEnable)
		end
		
		if Cfg.BarsDeathMod then
			if TargetFrameTextureFrameDeadText:GetText() then TargetFrameTextureFrameDeadText:Hide() end
			if FocusFrameTextureFrameDeadText:GetText() then FocusFrameTextureFrameDeadText:Hide() end
		end
end