------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Demorto#2660) Version 7.2.5.0 (19:35 07.08.2017)
------------------------------------------------------------------------------------
--
-- Icons Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

function IconsColorizeModule_Init(Cfg)

--local Cfg = NCConfig.IconsColorize

--/run NCConfig.IconsColorize.ModuleEnable = false

		hooksecurefunc("ActionButton_Update", function(self)
			if self:GetName():match("ExtraActionButton") then return end
			if Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				local Button = _G[self:GetName()]
				local Icon = _G[self:GetName().."Icon"]
				local Border = _G[self:GetName().."NormalTexture"]
				_G[self:GetName()].IsColorize = true
				Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
				Icon:SetTexCoord(.05, .95, .05, .95)
				Icon:SetPoint("TOPLEFT", Button, 0, 0)
				Icon:SetPoint("BOTTOMRIGHT", Button, 0, 0)
				Border:ClearAllPoints()
				Border:SetPoint("TOPLEFT", Button, -14, 14)
				Border:SetPoint("BOTTOMRIGHT", Button, 14, -14)
				if Cfg.Gradient then
					Border:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
				else
					Border:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
				end
			else
				if _G[self:GetName()].IsColorize then
					local Button = _G[self:GetName()]
					local Icon = _G[self:GetName().."Icon"]
					local Border = _G[self:GetName().."NormalTexture"]
					Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
					Icon:SetTexCoord(0, 1, 0, 1)
					Icon:SetPoint("TOPLEFT", Button, 0, 0)
					Icon:SetPoint("BOTTOMRIGHT", Button, 0, 0)
					Border:ClearAllPoints()
					Border:SetPoint("TOPLEFT", Button, -15, 15)
					Border:SetPoint("BOTTOMRIGHT", Button, 15, -15)
					Border:SetVertexColor(1, 1, 1, 1)
					_G[self:GetName()].IsColorize = false
				end
			end
		end)

		hooksecurefunc("ActionButton_UpdateUsable", function(self)
			if self:GetName():match("ExtraActionButton") then return end
			if Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				if Cfg.Gradient then
					_G[self:GetName().."NormalTexture"]:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
				else
					_G[self:GetName().."NormalTexture"]:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
				end
				_G[self:GetName().."NormalTexture"].IsColorize = true
			else
				if _G[self:GetName().."NormalTexture"].IsColorize then
					_G[self:GetName().."NormalTexture"]:SetVertexColor(1, 1, 1, 1)
					_G[self:GetName().."NormalTexture"].IsColorize = false
				end			
			end
		end)

		hooksecurefunc("ActionButton_ShowGrid", function(self)
			if self:GetName():match("ExtraActionButton") then return end
			if Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				if Cfg.Gradient then
					_G[self:GetName().."NormalTexture"]:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
				else
					_G[self:GetName().."NormalTexture"]:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
				end
				_G[self:GetName().."NormalTexture"].IsColorize = true
			else
				if _G[self:GetName().."NormalTexture"].IsColorize then
					_G[self:GetName().."NormalTexture"]:SetVertexColor(1, 1, 1, 1)
					_G[self:GetName().."NormalTexture"].IsColorize = false
				end	
			end
		end)

		 
		
		hooksecurefunc("StanceBar_Update",  function()
			if Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				for i = 1, NUM_STANCE_SLOTS do
					local Button = _G["StanceButton"..i]
					if Button then
						Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
						local Icon = _G["StanceButton"..i.."Icon"]
						local Border = _G["StanceButton"..i.."NormalTexture2"] or _G["StanceButton"..i.."NormalTexture"]
						Icon:SetTexCoord(.05, .95, .05, .95)
						Icon:SetPoint("TOPLEFT", Button, -1, 1)
						Icon:SetPoint("BOTTOMRIGHT", Button, 1, -1)
						Border:ClearAllPoints()
						Border:SetPoint("TOPLEFT", Button, -15, 15)
						Border:SetPoint("BOTTOMRIGHT", Button, 15, -15)
						if Cfg.Gradient then
							Border:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
						else
							Border:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
						end
						Button.IsColorize = true
					end
				end
			else
				for i = 1, NUM_STANCE_SLOTS do
					local Button = _G["StanceButton"..i]
					if Button then
						if Button.IsColorize then
							Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
							local Border = _G["StanceButton"..i.."NormalTexture2"] or _G["StanceButton"..i.."NormalTexture"]
							local Icon = _G["StanceButton"..i.."Icon"]
							Icon:SetTexCoord(0, 1, 0, 1)
							Icon:SetPoint("CENTER", Button, "CENTER", 0, 0)
							Border:ClearAllPoints()
							Border:SetPoint("CENTER", Button, "CENTER", 0, 0)
							Border:SetVertexColor(1, 1, 1, 1)
							Button.IsColorize = false
						end	
					end
				end		
			end
		end)
		
		hooksecurefunc("PetActionBar_Update",  function()
			if Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				for i = 1, NUM_PET_ACTION_SLOTS do
					local Button = _G["PetActionButton"..i]
					if Button then
						Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
						local Icon = _G["PetActionButton"..i.."Icon"]
						local Border = _G["PetActionButton"..i.."NormalTexture2"] or _G["PetActionButton"..i.."NormalTexture"]
						Icon:SetTexCoord(.05, .95, .05, .95)
						Icon:SetPoint("TOPLEFT", Button, -1, 1)
						Icon:SetPoint("BOTTOMRIGHT", Button, 1, -1)
						Border:ClearAllPoints()
						Border:SetPoint("TOPLEFT", Button, -15, 15)
						Border:SetPoint("BOTTOMRIGHT", Button, 15, -15)
						if Cfg.Gradient then
							Border:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
						else
							Border:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
						end
						Button.IsColorize = true
					end
				end
			else
				for i = 1, NUM_PET_ACTION_SLOTS do
					local Button = _G["PetActionButton"..i]
					if Button then
						if Button.IsColorize then
							Button:SetNormalTexture("Interface\\BUTTONS\\UI-Quickslot2")
							local Icon = _G["PetActionButton"..i.."Icon"]
							local Border = _G["PetActionButton"..i.."NormalTexture2"] or _G["PetActionButton"..i.."NormalTexture"]
							Icon:SetTexCoord(0, 1, 0, 1)
							Icon:SetPoint("CENTER", Button, "CENTER", 0, 0)
							Border:ClearAllPoints()
							Border:SetPoint("CENTER", Button, "CENTER", 0, 0)
							Border:SetVertexColor(1, 1, 1, 1)
							Button.IsColorize = false
						end
					end
				end
			end
		end)

		hooksecurefunc("AuraButton_Update", function(self, index)
			if Cfg.AuraBorder and Cfg.ModuleEnable then
				local ClassColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				if Cfg.Class then
					R, G, B = (ClassColor.r * 1.2), (ClassColor.g * 1.2), (ClassColor.b * 1.2)
				else
					R, G, B = Cfg.TopColor.Red, Cfg.TopColor.Green, Cfg.TopColor.Blue
				end
				local Button = _G[self..index]
				local Icon = _G[self..index.."Icon"]
				local Border = _G[self..index.."Border"]
				local NewBorder = _G[self..index.."Overlay"]
				
				if Icon then 
					Icon:SetTexCoord(.07, .93, .07, .93)
				end
				
				if Border then
					Border:SetTexture("Interface\\BUTTONS\\UI-Quickslot2")
					Border:ClearAllPoints()
					Border:SetPoint("TOPLEFT", Button, -12, 12)
					Border:SetPoint("BOTTOMRIGHT", Button, 12, -12)
					Border:SetTexCoord(0, 1, 0, 1)
					Border:SetVertexColor(1, 0, 0, 1)
				end
				
				if Button and not Border then
					if not NewBorder then
						NewBorder = Button:CreateTexture("$parentOverlay", "ARTWORK")
						NewBorder:SetParent(Button)
						NewBorder:SetTexture("Interface\\BUTTONS\\UI-Quickslot2")
						NewBorder:SetPoint("TOPLEFT", Button, -12, 12)
						NewBorder:SetPoint("BOTTOMRIGHT", Button, 12, -12)
					end
					NewBorder:Show()
					if Cfg.Gradient then
						NewBorder:SetGradientAlpha("VERTICAL", Cfg.BottomColor.Red, Cfg.BottomColor.Green, Cfg.BottomColor.Blue, Cfg.BottomColor.Alpha, R, G, B, Cfg.TopColor.Alpha)
					else
						NewBorder:SetVertexColor(R, G, B, Cfg.TopColor.Alpha)
					end
				end
				if Button then Button.IsColorize = true end
			else
				if ( _G[self..index] and _G[self..index].IsColorize ) then 
					local Button = _G[self..index]
					local Icon = _G[self..index.."Icon"]
					local Border = _G[self..index.."Border"]
					local NewBorder = _G[self..index.."Overlay"]
					
					if Icon then 
						Icon:SetTexCoord(0, 1, 0, 1)
					end

					if Border then
						Border:SetTexture("Interface\\Buttons\\UI-Debuff-Overlays")
						Border:ClearAllPoints()
						Border:SetPoint("CENTER", Button, "CENTER", 0, 0)
						Border:SetTexCoord(0.296875, 0.5703125, 0, 0.515625)
						Border:SetVertexColor(1, 0, 0, 1)
					end
					
					if NewBorder then
						NewBorder:Hide()
					end
					Button.IsColorize = false
				end
			end
		end)
return true
end

function IconsColorizeModule_Update()
	for i=1, 12 do
		ActionButton_Update(_G["ActionButton"..i])
        ActionButton_Update(_G["MultiBarBottomRightButton"..i])
        ActionButton_Update(_G["MultiBarBottomLeftButton"..i])
        ActionButton_Update(_G["MultiBarRightButton"..i])
        ActionButton_Update(_G["MultiBarLeftButton"..i])
	end
	StanceBar_Update()
	PetActionBar_Update()
	BuffFrame_Update()
end