﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Demorto#2660) Version 7.2.5.0 (19:35 07.08.2017)
------------------------------------------------------------------------------------
--
-- Name Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

function NamesColorizeModule_Init(Cfg)

	local DefaultFont, DefaultSize, DefaultStyle  = PlayerName:GetFont()

-- Хук на обновления фреймов

	hooksecurefunc("UnitFrame_Update", function(Frame)
		if NCConfig.Debug == true then
			print("NCDebug: "..Frame:GetName().."("..Frame.unit..") Update.")
		end

-- Обновление флейма петомца

		if Frame.unit == "pet" then
			if Cfg.ModuleEnable then
				PetName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				PetName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
			end

-- Обновление фрейма игрока

		elseif Frame.unit == "player" then
			if Cfg.ModuleEnable then
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						PlayerName:SetTextColor(C.r, C.g, C.b)
					else
						PlayerName:SetTextColor(1, 0.8, 0)
					end
					if IsInRaid() then
						local inInstance, instanceType = IsInInstance()
						if (inInstance and (instanceType ~= "arena")) then
							local NumGroupMembers = GetNumGroupMembers()
							for i=1, NumGroupMembers do
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
								if ( Name == UnitName(Frame.unit) ) then
									PlayerName:SetText("("..SubGroup..") "..UnitName(Frame.unit))
								end
							end
						end
					else
						PlayerName:SetText(UnitName(Frame.unit))
					end
				else
					PlayerName:SetTextColor(1, 0.8, 0)
				end
				PlayerName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				PlayerName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				PlayerName:SetTextColor(1, 0.8, 0)
			end

-- Обновление фрейма цели цели

		elseif Frame.unit == "targettarget" then
			if Cfg.ModuleEnable then
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						TargetFrameToTTextureFrameName:SetTextColor(C.r, C.g, C.b)
					else
						TargetFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
					end
				else
					TargetFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
				end
				TargetFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				TargetFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				TargetFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
			end

-- Обновление фрейма цели

		elseif Frame.unit == "target" then
			if Cfg.ModuleEnable then
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						TargetFrameTextureFrameName:SetTextColor(C.r, C.g, C.b)
					else
						TargetFrameTextureFrameName:SetTextColor(1, 0.8, 0)
					end
					if IsInRaid() then
						local inInstance, instanceType = IsInInstance()
						if (inInstance and (instanceType ~= "arena")) then
							local NumGroupMembers = GetNumGroupMembers()
							for i=1, NumGroupMembers do
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
								if ( Name == GetUnitName(Frame.unit, true) ) then
									TargetFrameTextureFrameName:SetText("("..SubGroup..") "..GetUnitName(Frame.unit, false))
								end
							end
						end
					end
				else
					TargetFrameTextureFrameName:SetTextColor(1, 0.8, 0)
				end
				local R, G, B, _ = UnitSelectionColor(Frame.unit)
				if ( not UnitPlayerControlled(Frame.unit) and UnitIsTapDenied(Frame.unit) ) then
					Frame.nameBackground:SetColorTexture(0.5, 0.5, 0.5, 0.5)
				else
					Frame.nameBackground:SetColorTexture(R, G, B, 0.25)
				end
				TargetFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				Frame.nameBackground:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-LevelBackground")
				if ( not UnitPlayerControlled(Frame.unit) and UnitIsTapDenied(Frame.unit) ) then
					Frame.nameBackground:SetVertexColor(0.5, 0.5, 0.5, 0.25)
				else
					Frame.nameBackground:SetVertexColor(UnitSelectionColor(Frame.unit))
				end
				TargetFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				TargetFrameTextureFrameName:SetTextColor(1, 0.8, 0)
			end

-- Обновление фрейма фокуса

		elseif Frame.unit == "focus" then
			if Cfg.ModuleEnable then
				local R, G, B, _ = Frame.nameBackground:GetVertexColor()
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						FocusFrameTextureFrameName:SetTextColor(C.r, C.g, C.b)
					else
						FocusFrameTextureFrameName:SetTextColor(1, 0.8, 0)
					end
					if IsInRaid() then
						local inInstance, instanceType = IsInInstance()
						if (inInstance and (instanceType ~= "arena")) then
							local NumGroupMembers = GetNumGroupMembers()
							for i=1, NumGroupMembers do
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
								if ( Name == GetUnitName(Frame.unit, true) ) then
									FocusFrameTextureFrameName:SetText("("..SubGroup..") "..GetUnitName(Frame.unit, false))
								end
							end
						end
					end
				else
					FocusFrameTextureFrameName:SetTextColor(1, 0.8, 0)
				end
				local R, G, B, _ = UnitSelectionColor(Frame.unit)
				if ( not UnitPlayerControlled(Frame.unit) and UnitIsTapDenied(Frame.unit) ) then
					Frame.nameBackground:SetColorTexture(0.5, 0.5, 0.5, 0.5)
				else
					Frame.nameBackground:SetColorTexture(R, G, B, 0.25)
				end
				FocusFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				Frame.nameBackground:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-LevelBackground")
				if ( not UnitPlayerControlled(Frame.unit) and UnitIsTapDenied(Frame.unit) ) then
					Frame.nameBackground:SetVertexColor(0.5, 0.5, 0.5, 0.25)
				else
					Frame.nameBackground:SetVertexColor(UnitSelectionColor(Frame.unit))
				end
				FocusFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				FocusFrameTextureFrameName:SetTextColor(1, 0.8, 0)
			end

-- Обновление фрейма цели фокуса

		elseif Frame.unit == "focus-target" then
			if Cfg.ModuleEnable then
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						FocusFrameToTTextureFrameName:SetTextColor(C.r, C.g, C.b)
					else
						FocusFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
					end
				else
					FocusFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
				end
				FocusFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				FocusFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				FocusFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
			end

-- Обновление фреймов боссов

		elseif strsub(Frame.unit, 1, 4) == "boss" then
			if Cfg.ModuleEnable then
				local R, G, B, _ = select(3, Frame:GetRegions()):GetVertexColor()
				select(3, Frame:GetRegions()):SetTexture(R, G, B, 0.5)
				_G[Frame:GetName().."TextureFrameName"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				local R, G, B, _ = select(3, Frame:GetRegions()):GetVertexColor()
				_G[Frame:GetName().."TextureFrameName"]:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				select(3, Frame:GetRegions()):SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-LevelBackground")
				select(3, Frame:GetRegions()):SetVertexColor(UnitSelectionColor(Frame.unit))
			end

-- Обновление фреймов группы

		elseif strsub(Frame.unit, 1, 5) == "party" then
			if Cfg.ModuleEnable then
				if UnitIsPlayer(Frame.unit) then
					local C = RAID_CLASS_COLORS[select(2, UnitClass(Frame.unit))]
					if C then
						_G[Frame:GetName().."Name"]:SetTextColor(C.r, C.g, C.b)
					else
						_G[Frame:GetName().."Name"]:SetTextColor(1, 0.8, 0)
					end
				else
					_G[Frame:GetName().."Name"]:SetTextColor(1, 0.8, 0)
				end
				_G[Frame:GetName().."Name"]:SetText(GetUnitName(Frame.unit, false))
				_G[Frame:GetName().."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			else
				_G[Frame:GetName().."Name"]:SetFont(DefaultFont, DefaultSize, DefaultStyle)
				_G[Frame:GetName().."Name"]:SetTextColor(1, 0.8, 0)
			end
		end
	end)

-- Обновление фрейма группы при изменении вида отображения (как рейд\как группа)

	hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
		if strsub(frame.unit, 1, 9) ~= "nameplate" then
			if Cfg.ModuleEnable then
				local DefaultFont, DefaultSize, DefaultStyle  = frame.name:GetFont()
				local ClassColorCheck = CompactUnitFrameProfilesGeneralOptionsFrameUseClassColors
				if not ClassColorCheck:GetChecked() then
					if UnitIsPlayer(frame.unit) then
						local C = RAID_CLASS_COLORS[select(2, UnitClass(frame.unit))]
						if C then
							frame.name:SetVertexColor(C.r, C.g, C.b)
						else
							frame.name:SetVertexColor(1, 1, 1)
						end
					else
						frame.name:SetVertexColor(1, 1, 1)
					end
					frame.name:SetFont(DefaultFont, DefaultSize, "OUTLINE")	
				else
					frame.name:SetVertexColor(1, 1, 1)
					frame.name:SetFont(DefaultFont, DefaultSize, "OUTLINE")
				end
			else
				frame.name:SetVertexColor(1, 1, 1)
				frame.name:SetFont(DefaultFont, DefaultSize, DefaultStyle)
			end
		end
	end)

	local NCArenaFrame = CreateFrame("Frame")
	NCArenaFrame:RegisterEvent("ARENA_OPPONENT_UPDATE")
	NCArenaFrame:SetScript("OnEvent", function()
		for i, AF in pairs({ArenaEnemyFrame1, ArenaEnemyFrame2, ArenaEnemyFrame3, ArenaEnemyFrame4, ArenaEnemyFrame5}) do
			if Cfg.ModuleEnable then
				if AF:IsShown() then
					local C = RAID_CLASS_COLORS[select(2, UnitClass("arena"..i))]
					if C then
						_G["ArenaEnemyFrame"..i.."Name"]:SetTextColor(C.r, C.g, C.b)
					end
					_G["ArenaEnemyFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
				end
			else
				_G["ArenaEnemyFrame"..i.."Name"]:SetTextColor(1, 0.8, 0)
				_G["ArenaEnemyFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, DefaultStyle)
			end
		end
	end)
	
	local function DecimalToHex(r,g,b)
		return string.format("|cff%02x%02x%02x", r*255, g*255, b*255)
	end

	function Hook_FriendsList_Update()
		if Cfg.FriendListColorize then
			local friendOffset = HybridScrollFrame_GetOffset(FriendsFrameFriendsScrollFrame)
			if not friendOffset then
				return
			end
			if friendOffset < 0 then
				friendOffset = 0
			end

			local numBNetTotal, numBNetOnline = BNGetNumFriends()
			if numBNetOnline > 0 then
				for i=1, numBNetOnline, 1 do
					local _, realName, _, _, toonName, toonID, client, _, _, _, _, _, _, _, _ = BNGetFriendInfo(i)
					if client == BNET_CLIENT_WOW then
						local _, _, _, realmName, _, _, _, class, _, zoneName, level, _ = BNGetGameAccountInfo(toonID)
						for k,v in pairs(LOCALIZED_CLASS_NAMES_MALE) do if class == v then class = k end end
						if GetLocale() ~= "enUS" then
							for k,v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do if class == v then class = k end end
						end
						local classc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
						if not classc then
							return
						end
						local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(i-friendOffset).."Name"]
						if nameString then
							nameString:SetText(realName.." ("..DecimalToHex(classc.r, classc.g, classc.b)..toonName.."|r, "..LEVEL_ABBR.." "..level..")")
						end
						if CanCooperateWithGameAccount(toonID) ~= true then
							local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(i-friendOffset).."Info"]
							if nameString then
								nameString:SetText(zoneName.." ("..realmName..")")
							end
						end
					end
				end
			end
			local numberOfFriends, onlineFriends = GetNumFriends()
			if onlineFriends > 0 then
				for i=1, onlineFriends, 1 do
					j = i + numBNetOnline
					local name, level, class, area, connected, status, note, RAF = GetFriendInfo(i);
					for k,v in pairs(LOCALIZED_CLASS_NAMES_MALE) do if class == v then class = k end end
					if GetLocale() ~= "enUS" then
						for k,v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do if class == v then class = k end end
					end
					local classc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
					if not classc then
						return
					end
					if connected then
						local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(j-friendOffset).."Name"]
						if nameString and name then
							nameString:SetText(DecimalToHex(classc.r, classc.g, classc.b)..name.."|r, "..LEVEL_ABBR.." "..level);
						end
					end
				end
			end
		end
	end
	
	hooksecurefunc("FriendsList_Update", Hook_FriendsList_Update)
	hooksecurefunc("HybridScrollFrame_Update", Hook_FriendsList_Update)
	
	return true
end

-- Обновление группы когда меняется отображение стиля группы на рейд

hooksecurefunc("CompactRaidFrameManager_UpdateShown", function(frame)
	for i, v in pairs({
		PartyMemberFrame1,
		PartyMemberFrame2,
		PartyMemberFrame3,
		PartyMemberFrame4,
	}) do
		if v:IsShown() then
			securecall("UnitFrame_Update", v)
		end
	end
end)

function NamesColorizeModule_Update()
	for i, v in pairs({
		PlayerFrame,
		TargetFrame,
		TargetFrameToT,
		FocusFrame,
		FocusFrameToT,
		PartyMemberFrame1,
		PartyMemberFrame2,
		PartyMemberFrame3,
		PartyMemberFrame4,
		Boss1TargetFrame,
		Boss2TargetFrame,
		Boss3TargetFrame,
		Boss4TargetFrame,
		Boss5TargetFrame,
		ArenaEnemyFrame1,
		ArenaEnemyFrame2,
		ArenaEnemyFrame3,
		ArenaEnemyFrame4,
		ArenaEnemyFrame5,
		PetFrame,
	}) do
		if v:IsShown() then
			securecall("UnitFrame_Update", v)
		end
	end
	for i=1, MAX_RAID_MEMBERS do
		local container = _G["CompactRaidFrame"..i]
		if container then
			securecall("CompactUnitFrame_UpdateAll", container)
		end
	end
end
 
--[[
if Cfg.RaidFix then
    local NCRaidFixFrame = CreateFrame("Frame")
 
    NCRaidFixFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
    NCRaidFixFrame:RegisterEvent("RAID_ROSTER_UPDATE")
    NCRaidFixFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
 
    NCRaidFixFrame:SetScript("OnEvent", function()
        if IsInRaid() then
            local container = CompactRaidFrameContainer
            local t = {
                discrete = "flush",
                flush = "discrete",
            }
 
            if issecurevariable("CompactRaidFrame1") or InCombatLockdown() or not container:IsShown() then return end
 
            local mode = container.groupMode
 
            CompactRaidFrameContainer_SetGroupMode(container, t[mode])
            CompactRaidFrameContainer_SetGroupMode(container, mode)
 
        else
            return
        end
    end)
end
]]--
