﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Demorto#2660) Version 7.2.5.0 (19:35 07.08.2017)
------------------------------------------------------------------------------------
--
-- Changelog:
--
-- 1.0
----------------------------
-- + Add coloring and adding shadows for frames with the names of players and monsters
-- + Add group numbers to the names
--
-- 1.1
----------------------------
-- - Remove show group number in the arena
-- ! Fix group number after leaving the arena
-- + Add Fix standard raid frame bug
-- + Add coloring HP bars (player\target\focus)
-- + Add nice info to bars (player\target\focus)
--
-- 1.2
----------------------------
-- + Add Config
-- + Add Friend List Names Colorize
-- + Add Smooth to bars
-- + Add to all HP bars coloring
-- + Add More speed to update names color
--
-- 1.3
----------------------------
-- - Boss HP Bars colorize
-- + Some check
--
-- 1.3.1
----------------------------
-- ! Fix Raid Frame Names Colorizing
--
-- 1.4
----------------------------
-- + 6.0 support
-- ! Fix BossTarget Error
-- ! Fix death text on players\target target
-- ! Fix Blizzard Healthbar Text
--
-- 1.5
----------------------------
-- ! rewrote code for most functions
-- - Smooth bar :(
--
-- 2.0b
----------------------------
-- + Options
-- + Locale
-- ! rewrote code for most functions
--
-- 2.1
----------------------------
-- ! Bug fix
--
-- 2.2
----------------------------
-- ! BNet 6.2.4 Fix
--
-- 2.3
----------------------------
-- ! Legion Fix
--
-- 2.4
----------------------------
-- ! Transfer all settings in interface menu
--
-- 7.2.5.0
----------------------------
-- ! Many rewritten functions.
-- + Stability of work.
-- + Fixes.
-- ! New numbers of versions based on the version of the game.
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

local NCFrame = CreateFrame("FRAME")

NCFrame:RegisterEvent("ADDON_LOADED")
NCFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

NCFrame:SetScript("OnEvent", function(Self, Event, ...)

	local Addon = ...
	local NiceColorizeLocale, CreateOptionsModule, NamesColorizeModule, BarsColorizeModule, FramesColorizeModule, IconsColorizeModule
	if (Event == "ADDON_LOADED") and (Addon == "NiceColorize") then
		if not NCConfigDB or NCConfigDef.Version > NCConfigDB.Version then
			NCConfigDB = CopyTable(NCConfigDef)
		end
		NCConfig = NCConfigDB
		if NiceColorizeLocale_Init() then NiceColorizeLocale = true else print("Module NiceColorizeLocale not load.") end
		if CreateOptions(NCConfig) then CreateOptionsModule = true else print("Module CreateOptions not load.") end
		if NamesColorizeModule_Init(NCConfig.NamesColorize) then NamesColorizeModule = true else print("Module NamesColorizeModule not load.") end
		if BarsColorizeModule_Init(NCConfig.BarsColorize) then BarsColorizeModule = true else print("Module BarsColorizeModule not load.") end
		if FramesColorizeModule_Init(NCConfig.FramesColorize) then FramesColorizeModule = true else print("Module FramesColorizeModule not load.") end
		if IconsColorizeModule_Init(NCConfig.IconsColorize) then IconsColorizeModule = true else print("Module IconsColorizeModule not load.") end 
		if NiceColorizeLocale and CreateOptions and NamesColorizeModule and BarsColorizeModule and FramesColorizeModule and IconsColorizeModule then
			DEFAULT_CHAT_FRAME:AddMessage(GetAddOnMetadata(Addon, "Title").." v."..GetAddOnMetadata(Addon, "Version").." Loaded!")
		else
			print("Some module of NiceColorize load error! Please send message to Demorto#2660.")
		end
		--DEFAULT_CHAT_FRAME:AddMessage(GetAddOnMetadata(Addon, "Title").." v."..GetAddOnMetadata(Addon, "Version").." Loaded!")
	end
	
	if ( Event == "PLAYER_ENTERING_WORLD" and Load ) then
	
		if not IsAddOnLoaded("Blizzard_TimeManager") then
			LoadAddOn("Blizzard_TimeManager")
		end
	
		BarsColorizeModule_Update(NCConfig.BarsColorize)
		NamesColorizeModule_Update()
		FramesColorizeModule_Update(NCConfig.FramesColorize)
		IconsColorizeModule_Update()
	end
end)