﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Demorto#2660) Version 7.2.5.0 (19:35 07.08.2017)
------------------------------------------------------------------------------------
--
-- Config of NiceColorize
--
------------------------------------------------------------------------------------
-- NiceConfig
------------------------------------------------------------------------------------

	NCConfigDef = {
		BarsColorize = {
			ModuleEnable = true,
			
			BarsColorizeEnable = true,
			BarsDeathMod = true,
			
			PlayerHealthBarText = "BOTH",
			PlayerPowerBarText = "BOTH",
			
			TargetHealthBarText = "BOTH",
			TargetPowerBarText = "BOTH",
			
			FocusHealthBarText = "BOTH",
			FocusPowerBarText = "BOTH",
			
			BarsTextFont = "STANDART",
			BarsTextSize = "STANDART",
			BarsTextStyle = "STANDART",
			
			TextAlpha = 0.5,
		},
		NamesColorize = {
			ModuleEnable = true,
			RaidFix = true,
			FriendListColorize = true,
		},
		FramesColorize = {
			ModuleEnable = true,
			Class = false,
			Gradient = false,
			TopColor = {
				Red = 1,
				Green = 1,
				Blue = 1,
				Alpha = 1,
			},
			BottomColor = {
				Red = 1,
				Green = 1,
				Blue = 1,
				Alpha = 1,
			},
		},
		IconsColorize = {
			ModuleEnable = true,
			AuraBorder = true,
			Class = false,
			Gradient = false,
			TopColor = {
				Red = 1,
				Green = 1,
				Blue = 1,
				Alpha = 1,
			},
			BottomColor = {
				Red = 1,
				Green = 1,
				Blue = 1,
				Alpha = 1,
			},
		},
		Debug = false,
		Version = 1,
	}

NCConfigPanel = {};
 NCConfigPanel.panel = CreateFrame( "Frame", "NiceColorizeConfigPanel", UIParent );
 NCConfigPanel.panel.name = "NiceColorize";
 InterfaceOptions_AddCategory(NCConfigPanel.panel);

function CreateSlider(Name, Min, Max, Step, Parent, AnchorTo, Point, PointTo, X, Y, Tooltip, Text, OnChange, Var)
	local frame = CreateFrame('Slider', Name, Parent, 'OptionsSliderTemplate')
	frame:ClearAllPoints()
	frame:SetPoint(Point, AnchorTo, PointTo, X, Y)
	frame:SetMinMaxValues(Min, Max)
	frame:SetValueStep(Step)
	frame:SetValue(Var)
	frame.tooltipText = Tooltip
	local frametext = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	frametext:SetPoint("TOP", frame, "BOTTOM", 0, 0)
	frametext:SetText(format("%.0f%%",frame:GetValue()))
	getglobal(frame:GetName()..'Low'):SetText(Min.."%")
	getglobal(frame:GetName()..'High'):SetText(Max.."%")
	getglobal(frame:GetName()..'Text'):SetText(Text)
	getglobal(frame:GetName()..'Text'):SetFontObject("GameFontNormalSmall")
	frame:SetScript("OnEnable", function()
		_G[frame:GetName() .. "Low"]:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
		_G[frame:GetName() .. "High"]:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
		_G[frame:GetName() .. "Text"]:SetVertexColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
		frametext:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
	end)
	frame:SetScript("OnDisable", function()
		_G[frame:GetName() .. "Low"]:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
		_G[frame:GetName() .. "High"]:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
		_G[frame:GetName() .. "Text"]:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
		frametext:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
	end)
	frame:SetScript("OnValueChanged", function(self, value)
		frametext:SetText(format("%.0f%%",frame:GetValue()))
		OnChange(format("%.0f",frame:GetValue()))
	end)
	frame:Show()
 end

function CreateCheckButton(Name, Template, Parent, AnchorTo, Point, PointTo, X, Y, Tooltip, Text, OnClickFunction, Var)
	local frame = CreateFrame("CheckButton", Name, Parent, Template)
	frame:ClearAllPoints()
	frame:SetPoint(Point, AnchorTo, PointTo, X, Y)
	_G[frame:GetName() .. "Text"]:SetText(Text)
	frame:SetScript("OnEnable", function() _G[frame:GetName() .. "Text"]:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b) end)
	frame:SetScript("OnDisable", function() _G[frame:GetName() .. "Text"]:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b) end)
	frame.tooltipText = Tooltip 
	frame:SetChecked(Var)
	frame:SetScript("OnClick", OnClickFunction)
	frame:RegisterEvent("PLAYER_ENTERING_WORLD")
	frame:SetScript("OnEvent", OnClickFunction)
	return frame
end

	local function CreateDropDownMenu(Name, Parent, AnchorTo, Point, PointTo, X, Y, Tooltip, Text, Items, OnClickFunction, Var)
	
		local frame = CreateFrame("Button", Name, Parent, "UIDropDownMenuTemplate")
		frame:ClearAllPoints()
		frame:SetPoint(Point, AnchorTo, PointTo, X, Y)
		frame.tooltip = Tooltip
		frame:Show()
		frameText = frame:CreateFontString(Name.."Label", "BACKGROUND", "GameFontNormalSmall")
		frameText:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 16, 3)
		frameText:SetText(Text)
		frame:SetScript("OnEnter", function(self)
			if ( not self.isDisabled ) then
				GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
				GameTooltip:SetText(self.tooltip, nil, nil, nil, nil, 1);
			end
		end)
		frame:SetScript("OnLeave", GameTooltip_Hide)

		local function OnClick(self)
			UIDropDownMenu_SetSelectedID(frame, self:GetID())
			OnClickFunction(self)
		end
 
		local function initialize(self, level)
			local info = UIDropDownMenu_CreateInfo()
			for k, v in pairs(Items) do
				info = UIDropDownMenu_CreateInfo()
				info.text = v[2]
				info.value = v[1]
				info.func = OnClick
				UIDropDownMenu_AddButton(info, level)
			end
		end

		UIDropDownMenu_Initialize(frame, initialize)
		UIDropDownMenu_SetWidth(frame, 100);
		UIDropDownMenu_SetButtonWidth(frame, 124)
		UIDropDownMenu_JustifyText(frame, "LEFT")
		UIDropDownMenu_SetSelectedID(frame, 1)
		for k, v in pairs(Items) do
			if Var == v[1] then
				UIDropDownMenu_SetSelectedID(frame, k)
			end
		end
	end
	
function CreateColorPickerButton(Name, Template, Parent, AnchorTo, Point, PointTo, X, Y, Tooltip, Text, Opacity, Function, VarR, VarG, VarB, VarA)
	local frame = CreateFrame("Button", Name, Parent)
	frame.hasOpacity = Opacity
	frame:SetWidth(18)
	frame:SetHeight(18)
	frame:SetPoint(Point, AnchorTo, PointTo, X, Y)
	frame.tooltip = Tooltip
	if frame.hasOpacity then
		frame.swatchFunc = function()
			local r, g, b = ColorPickerFrame:GetColorRGB()
			local a = 1 - OpacitySliderFrame:GetValue()
			frame.colorpicker:SetVertexColor(r, g, b, a)
			Function(r, g, b, a)
		end
		frame.opacityFunc = frame.swatchFunc
		frame.cancelFunc = function()
			local prev = ColorPickerFrame.previousValues
			frame.colorpicker:SetVertexColor(prev.r, prev.g, prev.b, 1 - prev.opacity)
			Function(prev.r, prev.g, prev.b, 1 - prev.opacity)
		end
	else
		frame.swatchFunc = function()
			frame:SetVertexColor(ColorPickerFrame:GetColorRGB())
			Function(ColorPickerFrame:GetColorRGB())
		end
		frame.cancelFunc = function()
			frame.colorpicker:SetVertexColor(ColorPicker_GetPreviousValues())
			Function(ColorPicker_GetPreviousValues())
		end
	end
	local colorpicker = frame:CreateTexture(nil, "OVERLAY")
	colorpicker:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
	colorpicker:SetAllPoints(frame)
	colorpicker:SetVertexColor(VarR, VarG, VarB, VarA)
	frame:SetNormalTexture(colorpicker)
	frame.colorpicker = colorpicker

	local background = frame:CreateTexture(nil, "BACKGROUND")
	background:SetWidth(16)
	background:SetHeight(16)
	background:SetTexture(1, 1, 1)
	local color = _G["HIGHLIGHT_FONT_COLOR"]
	background:SetVertexColor(color.r, color.g, color.b)
	background:SetPoint("CENTER")
	frame.background = background

	local ftext = frame:CreateFontString(nil, "ARTWORK", Template)
	ftext:SetPoint("LEFT", frame, "RIGHT", 4, 0)
	ftext:SetText(Text)
	frame.text = ftext
	
	frame:SetScript("OnEnable", function()
		frame.text:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
		frame.background:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
	end)
	frame:SetScript("OnDisable", function()
		frame.text:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
		frame.background:SetVertexColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
	end)
	
	frame:SetScript("OnEnter", function()
		local color = _G["NORMAL_FONT_COLOR"]
		frame.background:SetVertexColor(color.r, color.g, color.b)
		GameTooltip:SetOwner(frame, "ANCHOR_TOPLEFT")
		GameTooltip:SetText(frame.tooltip, nil, nil, nil, nil, true);
	end)
	
	frame:SetScript("OnLeave", function()
		local color = _G["HIGHLIGHT_FONT_COLOR"]
		frame.background:SetVertexColor(color.r, color.g, color.b)
		GameTooltip_Hide()
	end)
	
	frame:SetScript("OnClick", function()
		if ColorPickerFrame:IsShown() then
			ColorPickerFrame:Hide()
		else
			frame.r, frame.g, frame.b, frame.opacity = frame.colorpicker:GetVertexColor()
			frame.opacity = 1 - frame.opacity
			OpenColorPicker(frame)
			ColorPickerFrame:SetFrameStrata("TOOLTIP")
			ColorPickerFrame:Raise()
		end
	end)
end

local function NCBCModuleEnable(self, button, down)
	if self:GetChecked() then
		NCConfig.BarsColorize.ModuleEnable = true
		NCConfig.BarsColorize.BarsColorizeEnable = true
		NiceColorizeBarsColorizeBarsColorizeEnable:Enable()
		--NiceColorizeBarsColorizeBarsDeathMod:Enable()
		NiceColorizeBarsColorizeTextAlpha:Enable()
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizePlayerHealthBarText)
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizePlayerPowerBarText)
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizeTargetHealthBarText)
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizeTargetPowerBarText)
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizeFocusHealthBarText)
		UIDropDownMenu_EnableDropDown(NiceColorizeBarsColorizeFocusPowerBarText)
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	else
		NCConfig.BarsColorize.ModuleEnable = false
		NCConfig.BarsColorize.BarsColorizeEnable = false
		NiceColorizeBarsColorizeBarsColorizeEnable:Disable()
		--NiceColorizeBarsColorizeBarsDeathMod:Disable()
		NiceColorizeBarsColorizeTextAlpha:Disable()
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizePlayerHealthBarText)
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizePlayerPowerBarText)
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizeTargetHealthBarText)
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizeTargetPowerBarText)
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizeFocusHealthBarText)
		UIDropDownMenu_DisableDropDown(NiceColorizeBarsColorizeFocusPowerBarText)
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	end
end

local function NCBCBarsColorizeEnable(self, button, down)
	if self:GetChecked() then
		NCConfig.BarsColorize.BarsColorizeEnable = true
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	else
		NCConfig.BarsColorize.BarsColorizeEnable = false
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	end
end

local function NCBCBarsDeathMod(self, button, down)
	if self:GetChecked() then
		NCConfig.BarsColorize.BarsDeathMod = true
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	else
		NCConfig.BarsColorize.BarsDeathMod = false
		BarsColorizeModule_Update(NCConfig.BarsColorize)
	end
end

local function NCBCPlayerHealthBarText(self)
	NCConfig.BarsColorize.PlayerHealthBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCPlayerPowerBarText(self)
	NCConfig.BarsColorize.PlayerPowerBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCTargetHealthBarText(self)
	NCConfig.BarsColorize.TargetHealthBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCTargetPowerBarText(self)
	NCConfig.BarsColorize.TargetPowerBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCFocusHealthBarText(self)
	NCConfig.BarsColorize.FocusHealthBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCFocusPowerBarText(self)
	NCConfig.BarsColorize.FocusPowerBarText = self.value
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCBCTextAlpha(self)
	NCConfig.BarsColorize.TextAlpha = self/100
	BarsColorizeModule_Update(NCConfig.BarsColorize)
end

local function NCNCModuleEnable(self, button, down)
	NCConfig.NamesColorize.ModuleEnable = self:GetChecked()
	NamesColorizeModule_Update()
end

local function NCNCFriendListColorize(self, button, down)
	NCConfig.NamesColorize.FriendListColorize = self:GetChecked()
	FriendsList_Update()
end

local function NCFCClass(self, button, down)
if NCConfig.FramesColorize.ModuleEnable then
	if self:GetChecked() then
		NCConfig.FramesColorize.Class = true
		NiceColorizeFramesColorizeTopColor:Disable()
		if NCConfig.FramesColorize.Gradient then
			NiceColorizeFramesColorizeBottomColor:Enable()
		else
			NiceColorizeFramesColorizeBottomColor:Disable()
		end
		FramesColorizeModule_Update(NCConfig.FramesColorize)
	else
		NCConfig.FramesColorize.Class = false
		NiceColorizeFramesColorizeTopColor:Enable()
		if NCConfig.FramesColorize.Gradient then
			NiceColorizeFramesColorizeBottomColor:Enable()
		else
			NiceColorizeFramesColorizeBottomColor:Disable()
		end
		FramesColorizeModule_Update(NCConfig.FramesColorize)
	end
end
end

local function NCFCGradient(self, button, down)
if NCConfig.FramesColorize.ModuleEnable then
	if self:GetChecked() then
		NCConfig.FramesColorize.Gradient = true
		NiceColorizeFramesColorizeBottomColor:Enable()
		FramesColorizeModule_Update(NCConfig.FramesColorize)
	else
		NCConfig.FramesColorize.Gradient = false
		NiceColorizeFramesColorizeBottomColor:Disable()
		FramesColorizeModule_Update(NCConfig.FramesColorize)
	end
end
end

local function NCFCModuleEnable(self, button, down)
	if self:GetChecked() then
		NCConfig.FramesColorize.ModuleEnable = true
		NiceColorizeFramesColorizeGradient:Enable()
		NiceColorizeFramesColorizeClass:Enable()
		NCFCClass(NiceColorizeFramesColorizeClass)
		NCFCGradient(NiceColorizeFramesColorizeGradient)
	else
		NCConfig.FramesColorize.ModuleEnable = false
		NiceColorizeFramesColorizeClass:Disable()
		NiceColorizeFramesColorizeGradient:Disable()
		NiceColorizeFramesColorizeBottomColor:Disable()
		NiceColorizeFramesColorizeTopColor:Disable()
	end
	FramesColorizeModule_Update(NCConfig.FramesColorize)
end

local function NCFCTopColor(r, g, b, a)
	NCConfig.FramesColorize.TopColor.Red, NCConfig.FramesColorize.TopColor.Green, NCConfig.FramesColorize.TopColor.Blue, NCConfig.FramesColorize.TopColor.Alpha = r, g, b, a
	FramesColorizeModule_Update(NCConfig.FramesColorize)
end

local function NCFCBottomColor(r, g, b, a)
	NCConfig.FramesColorize.BottomColor.Red, NCConfig.FramesColorize.BottomColor.Green, NCConfig.FramesColorize.BottomColor.Blue, NCConfig.FramesColorize.BottomColor.Alpha = r, g, b, a
	FramesColorizeModule_Update(NCConfig.FramesColorize)
end



local function NCICClass(self, button, down)
if NCConfig.IconsColorize.ModuleEnable then
	if self:GetChecked() then
		NCConfig.IconsColorize.Class = true
		NiceColorizeIconsColorizeTopColor:Disable()
		if NCConfig.IconsColorize.Gradient then
			NiceColorizeIconsColorizeBottomColor:Enable()
		else
			NiceColorizeIconsColorizeBottomColor:Disable()
		end
		IconsColorizeModule_Update()
	else
		NCConfig.IconsColorize.Class = false
		NiceColorizeIconsColorizeTopColor:Enable()
		if NCConfig.IconsColorize.Gradient then
			NiceColorizeIconsColorizeBottomColor:Enable()
		else
			NiceColorizeIconsColorizeBottomColor:Disable()
		end
		IconsColorizeModule_Update()
	end
end
end

local function NCICGradient(self, button, down)
if NCConfig.IconsColorize.ModuleEnable then
	if self:GetChecked() then
		NCConfig.IconsColorize.Gradient = true
		NiceColorizeIconsColorizeBottomColor:Enable()
		IconsColorizeModule_Update()
	else
		NCConfig.IconsColorize.Gradient = false
		NiceColorizeIconsColorizeBottomColor:Disable()
		IconsColorizeModule_Update()
	end
end
end

local function NCICModuleEnable(self, button, down)
	if self:GetChecked() then
		NCConfig.IconsColorize.ModuleEnable = true
		NiceColorizeIconsColorizeGradient:Enable()
		NiceColorizeIconsColorizeClass:Enable()
		NCICClass(NiceColorizeIconsColorizeClass)
		NCICGradient(NiceColorizeIconsColorizeGradient)
	else
		NCConfig.IconsColorize.ModuleEnable = false
		NiceColorizeIconsColorizeClass:Disable()
		NiceColorizeIconsColorizeGradient:Disable()
		NiceColorizeIconsColorizeBottomColor:Disable()
		NiceColorizeIconsColorizeTopColor:Disable()
	end
	IconsColorizeModule_Update()
end

local function NCICTopColor(r, g, b, a)
	NCConfig.IconsColorize.TopColor.Red, NCConfig.IconsColorize.TopColor.Green, NCConfig.IconsColorize.TopColor.Blue, NCConfig.IconsColorize.TopColor.Alpha = r, g, b, a
	IconsColorizeModule_Update()
end

local function NCICBottomColor(r, g, b, a)
	NCConfig.IconsColorize.BottomColor.Red, NCConfig.IconsColorize.BottomColor.Green, NCConfig.IconsColorize.BottomColor.Blue, NCConfig.IconsColorize.BottomColor.Alpha = r, g, b, a
	IconsColorizeModule_Update()
end

function CreateOptions(NCConfig)

	local HealthBarTextDropDownItems = {
	   { "BOTH", Locale.HealthBarTextDropDownItemsCaption[1] },
	   { "PERCENT", Locale.HealthBarTextDropDownItemsCaption[2] },
	   { "CURRENT", Locale.HealthBarTextDropDownItemsCaption[3] },
	   { "HIDE", Locale.HealthBarTextDropDownItemsCaption[4]},
	}
	
CreateCheckButton("NiceColorizeBarsColorizeModuleEnable", "InterfaceOptionsCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeConfigPanel, "TOPLEFT", "TOPLEFT", 16, -16, Locale.NiceColorizeBarsColorizeModuleEnableTooltip, "|cffFF0000NC:|r "..Locale.NiceColorizeBarsColorizeModuleEnableCaption, NCBCModuleEnable, NCConfig.BarsColorize.ModuleEnable)

CreateCheckButton("NiceColorizeBarsColorizeBarsColorizeEnable", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeBarsColorizeModuleEnable, "TOPLEFT", "BOTTOMLEFT", 16, 4, Locale.NiceColorizeBarsColorizeBarsColorizeEnableTooltip, Locale.NiceColorizeBarsColorizeBarsColorizeEnableCaption, NCBCBarsColorizeEnable, NCConfig.BarsColorize.BarsColorizeEnable)

--CreateCheckButton("NiceColorizeBarsColorizeBarsDeathMod", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeBarsColorizeBarsColorizeEnable, "TOPLEFT", "BOTTOMLEFT", 0, 4, "Включить отображение текста о том что цель\игрок мертвы на полосках жизни", "Надписи о неживой цели", NCBCBarsColorizeEnable, NCConfig.BarsColorize.BarsDeathMod)

CreateDropDownMenu("NiceColorizeBarsColorizePlayerHealthBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizeBarsColorizeEnable, "TOPLEFT", "BOTTOMLEFT", -13, -16, Locale.NiceColorizeBarsColorizePlayerHealthBarTextTooltip, Locale.NiceColorizeBarsColorizePlayerHealthBarTextCaption, HealthBarTextDropDownItems, NCBCPlayerHealthBarText, NCConfig.BarsColorize.PlayerHealthBarText)
CreateDropDownMenu("NiceColorizeBarsColorizePlayerPowerBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizePlayerHealthBarText, "TOPLEFT", "TOPRIGHT", 80, 0, Locale.NiceColorizeBarsColorizePlayerPowerBarTextTooltip, Locale.NiceColorizeBarsColorizePlayerPowerBarTextCaption, HealthBarTextDropDownItems, NCBCPlayerPowerBarText, NCConfig.BarsColorize.PlayerPowerBarText)

CreateDropDownMenu("NiceColorizeBarsColorizeTargetHealthBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizePlayerHealthBarText, "TOPLEFT", "BOTTOMLEFT", 0, -16, Locale.NiceColorizeBarsColorizeTargetHealthBarTextTooltip, Locale.NiceColorizeBarsColorizeTargetHealthBarTextCaption, HealthBarTextDropDownItems, NCBCTargetHealthBarText, NCConfig.BarsColorize.TargetHealthBarText)
CreateDropDownMenu("NiceColorizeBarsColorizeTargetPowerBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizeTargetHealthBarText, "TOPLEFT", "TOPRIGHT", 80, 0, Locale.NiceColorizeBarsColorizeTargetPowerBarTextTooltip, Locale.NiceColorizeBarsColorizeTargetPowerBarTextCaption, HealthBarTextDropDownItems, NCBCTargetPowerBarText, NCConfig.BarsColorize.TargetPowerBarText)

CreateDropDownMenu("NiceColorizeBarsColorizeFocusHealthBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizeTargetHealthBarText, "TOPLEFT", "BOTTOMLEFT", 0, -16, Locale.NiceColorizeBarsColorizeFocusHealthBarTextTooltip, Locale.NiceColorizeBarsColorizeFocusHealthBarTextCaption, HealthBarTextDropDownItems, NCBCFocusHealthBarText, NCConfig.BarsColorize.FocusHealthBarText)
CreateDropDownMenu("NiceColorizeBarsColorizeFocusPowerBarText", NiceColorizeConfigPanel, NiceColorizeBarsColorizeFocusHealthBarText, "TOPLEFT", "TOPRIGHT", 80, 0, Locale.NiceColorizeBarsColorizeFocusPowerBarTextTooltip, Locale.NiceColorizeBarsColorizeFocusPowerBarTextCaption, HealthBarTextDropDownItems, NCBCFocusPowerBarText, NCConfig.BarsColorize.FocusPowerBarText)

CreateSlider("NiceColorizeBarsColorizeTextAlpha", 0, 100, 1, NiceColorizeConfigPanel, NiceColorizeBarsColorizeFocusPowerBarText, "TOP", "BOTTOMLEFT", 0, -16, Locale.NiceColorizeBarsColorizeTextAlphaTooltip, Locale.NiceColorizeBarsColorizeTextAlphaCaption, NCBCTextAlpha, NCConfig.BarsColorize.TextAlpha * 100)

CreateCheckButton("NiceColorizeNamesColorizeModuleEnable", "InterfaceOptionsCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeConfigPanel, "TOPLEFT", "TOPLEFT", 16, -260, Locale.NiceColorizeNamesColorizeModuleEnableTooltip, Locale.NiceColorizeNamesColorizeModuleEnableCaption, NCNCModuleEnable, NCConfig.NamesColorize.ModuleEnable)

CreateCheckButton("NiceColorizeNamesColorizeFriendListColorize", "InterfaceOptionsCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeNamesColorizeModuleEnable, "TOPLEFT", "BOTTOMLEFT", 0, -4, Locale.NiceColorizeNamesColorizeFriendListColorizeTooltip, Locale.NiceColorizeNamesColorizeFriendListColorizeCaption, NCNCFriendListColorize, NCConfig.NamesColorize.FriendListColorize)



CreateCheckButton("NiceColorizeFramesColorizeModuleEnable", "InterfaceOptionsCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeNamesColorizeFriendListColorize, "TOPLEFT", "BOTTOMLEFT", 0, -8, Locale.NiceColorizeFramesColorizeModuleEnableTooltip, Locale.NiceColorizeFramesColorizeModuleEnableCaption, NCFCModuleEnable, NCConfig.FramesColorize.ModuleEnable)

CreateCheckButton("NiceColorizeFramesColorizeClass", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeFramesColorizeModuleEnable, "TOPLEFT", "BOTTOMLEFT", 16, 4, Locale.NiceColorizeFramesColorizeClassTooltip, Locale.NiceColorizeFramesColorizeClassCaption, NCFCClass, NCConfig.FramesColorize.Class)

CreateCheckButton("NiceColorizeFramesColorizeGradient", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeFramesColorizeClass, "TOPLEFT", "BOTTOMLEFT", 0, 4, Locale.NiceColorizeFramesColorizeGradientTooltip, Locale.NiceColorizeFramesColorizeGradientCaption, NCFCGradient, NCConfig.FramesColorize.Gradient)

CreateColorPickerButton("NiceColorizeFramesColorizeTopColor", "GameFontHighlightSmall", NiceColorizeConfigPanel, NiceColorizeFramesColorizeGradient, "TOPLEFT", "BOTTOMLEFT", 4, 1, Locale.NiceColorizeFramesColorizeTopColorTooltip, Locale.NiceColorizeFramesColorizeTopColorCaption, true, NCFCTopColor, NCConfig.FramesColorize.TopColor.Red, NCConfig.FramesColorize.TopColor.Green, NCConfig.FramesColorize.TopColor.Blue, NCConfig.FramesColorize.TopColor.Alpha)

CreateColorPickerButton("NiceColorizeFramesColorizeBottomColor", "GameFontHighlightSmall", NiceColorizeConfigPanel, NiceColorizeFramesColorizeTopColor, "TOPLEFT", "BOTTOMLEFT", 0, -4, Locale.NiceColorizeFramesColorizeBottomColorTooltip, Locale.NiceColorizeFramesColorizeBottomColorCaption, true, NCFCBottomColor, NCConfig.FramesColorize.BottomColor.Red, NCConfig.FramesColorize.BottomColor.Green, NCConfig.FramesColorize.BottomColor.Blue, NCConfig.FramesColorize.BottomColor.Alpha)



CreateCheckButton("NiceColorizeIconsColorizeModuleEnable", "InterfaceOptionsCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeFramesColorizeBottomColor, "TOPLEFT", "BOTTOMLEFT", -20, -8, Locale.NiceColorizeIconsColorizeModuleEnableTooltip, Locale.NiceColorizeIconsColorizeModuleEnableCaption, NCICModuleEnable, NCConfig.IconsColorize.ModuleEnable)

CreateCheckButton("NiceColorizeIconsColorizeClass", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeIconsColorizeModuleEnable, "TOPLEFT", "BOTTOMLEFT", 16, 4, Locale.NiceColorizeIconsColorizeClassTooltip, Locale.NiceColorizeIconsColorizeClassCaption, NCICClass, NCConfig.IconsColorize.Class)

CreateCheckButton("NiceColorizeIconsColorizeGradient", "InterfaceOptionsSmallCheckButtonTemplate", NiceColorizeConfigPanel, NiceColorizeIconsColorizeClass, "TOPLEFT", "BOTTOMLEFT", 0, 4, Locale.NiceColorizeIconsColorizeGradientTooltip, Locale.NiceColorizeIconsColorizeGradientCaption, NCICGradient, NCConfig.IconsColorize.Gradient)

CreateColorPickerButton("NiceColorizeIconsColorizeTopColor", "GameFontHighlightSmall", NiceColorizeConfigPanel, NiceColorizeIconsColorizeGradient, "TOPLEFT", "BOTTOMLEFT", 4, 1, Locale.NiceColorizeIconsColorizeTopColorTooltip, Locale.NiceColorizeIconsColorizeTopColorCaption, true, NCICTopColor, NCConfig.IconsColorize.TopColor.Red, NCConfig.IconsColorize.TopColor.Green, NCConfig.IconsColorize.TopColor.Blue, NCConfig.IconsColorize.TopColor.Alpha)

CreateColorPickerButton("NiceColorizeIconsColorizeBottomColor", "GameFontHighlightSmall", NiceColorizeConfigPanel, NiceColorizeIconsColorizeTopColor, "TOPLEFT", "BOTTOMLEFT", 0, -4, Locale.NiceColorizeIconsColorizeBottomColorTooltip, Locale.NiceColorizeIconsColorizeBottomColorCaption, true, NCICBottomColor, NCConfig.IconsColorize.BottomColor.Red, NCConfig.IconsColorize.BottomColor.Green, NCConfig.IconsColorize.BottomColor.Blue, NCConfig.IconsColorize.BottomColor.Alpha)

return true
end